window.PS = window.PS || {};
PS.util = PS.util || {};

(function (PS) {

    'use strict';

    var encryption = {
        encrypt: function (string, key) {
            var encryptedString = string;

            if (!!key) {

                var rsa = new pidCrypt.RSA();

                key = pidCryptUtil.decodeBase64(key);
                // ASN1 parsing
                var asn = pidCrypt.ASN1.decode(pidCryptUtil.toByteArray(key));
                var tree = asn.toHexTree();

                // setting the public key for encryption with retrieved ASN.1 tree
                rsa.setPublicKeyFromASN(tree);

                var crypted = rsa.encrypt(encryptedString);
                encryptedString = pidCryptUtil.encodeBase64(pidCryptUtil.convertFromHex(crypted));
            }

            return encryptedString;
        },

        getPublicKey: function (apiUrl, success, failure, timeout) {

            if (apiUrl.length > 0) {
                PS.util.ajax(apiUrl, success, failure, 'encryption', timeout);
            }
        }
    };

    PS.util.encryption = encryption;

}(PS));