/*
 * Copyright (C) 2014 IG Group (webapisupport@ig.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var mode = "prod";
var servers = {
   "dev_ig": "https://net-api.ig.com",
   "net_ig": "https://net-api.ig.com",
   "web_ig": "https://web-api.ig.com",
   "demo_ig": "https://demo-api.ig.com",
   "prod_ig": "https://api.ig.com"
};
var serverSelection = null;
var serverType = null;
var deployType = null;
var req = null;
var radio_button_value = "Buy";
var radio_button_value_v1 = "Buy";

var actionGlobal;

var isLoggedIn = false;
var isLivePressed = true;
var colorPropertyFound = false;

var clusterColorForLive = "Red";
var clusterColorForDark = "Red";

var labelFontColorForPressed = "Red";
var labelFontColorForNotPressed = "White";

var lastResponse;

var oauthRefreshTimer;

$(function () {

   configure();

   // Normal elements
   //$("#url").attr("disabled", "disabled");

   // Authentication container
   var authenticationParentElement = $("#action_template_heading").clone();
   $(authenticationParentElement).removeAttr('id').removeAttr('style');
   $(authenticationParentElement).find('#action_title_heading').text("Connect");
   $(authenticationParentElement).attr("title", "Click to login");
   $(authenticationParentElement).css("display", "block");

   // Searches Container
   var searchParentElement = $("#action_template_heading").clone();
   $(searchParentElement).removeAttr('id').removeAttr('style');
   $(searchParentElement).find('#action_title_heading').text("Market Search");
   $(searchParentElement).addClass('optional');
   $(searchParentElement).css("display", "none");

   // Watchlist Container
   var watchlistParentElement = $("#action_template_heading").clone();
   $(watchlistParentElement).removeAttr('id').removeAttr('style');
   $(watchlistParentElement).find('#action_title_heading').text("Watchlist");
   $(watchlistParentElement).addClass('optional');
   $(watchlistParentElement).css("display", "none");

   // Client-account Container
   var clientParentElement = $("#action_template_heading").clone();
   $(clientParentElement).removeAttr('id').removeAttr('style');
   $(clientParentElement).find('#action_title_heading').text("Client Details");
   $(clientParentElement).addClass('optional');
   $(clientParentElement).css("display", "none");

   // Trading Container
   var tradingParentElement = $("#action_template_heading").clone();
   $(tradingParentElement).removeAttr('id').removeAttr('style');
   $(tradingParentElement).find('#action_title_heading').text("Trading - Positions");
   $(tradingParentElement).addClass('optional');
   $(tradingParentElement).css("display", "none");

    var tradingSprintMarketContainer = $("#action_template_heading").clone();
    $(tradingSprintMarketContainer).removeAttr('id').removeAttr('style');
    $(tradingSprintMarketContainer).find('#action_title_heading').text("Sprint market");

   // Trading Container
   var tradingWOParentElement = $("#action_template_heading").clone();
   $(tradingWOParentElement).removeAttr('id').removeAttr('style');
   $(tradingWOParentElement).find('#action_title_heading').text("Trading - Working Orders");
   $(tradingWOParentElement).addClass('optional');
   $(tradingWOParentElement).css("display", "none");

   // Account Activity Container
   var accountActivityParentElement = $("#action_template_heading").clone();
   $(accountActivityParentElement).removeAttr('id').removeAttr('style');
   $(accountActivityParentElement).find('#action_title_heading').text("Account Activity");
   $(accountActivityParentElement).addClass('optional');
   $(accountActivityParentElement).css("display", "none");

   // Historic Price Search Container
   var historicPriceSearchParentElement = $("#action_template_heading").clone();
   $(historicPriceSearchParentElement).removeAttr('id').removeAttr('style');
   $(historicPriceSearchParentElement).find('#action_title_heading').text("Prices");
   $(historicPriceSearchParentElement).addClass('optional');
   $(historicPriceSearchParentElement).css("display", "none");

   // Client Sentiment Container
   var clientSentimentParentElement = $("#action_template_heading").clone();
   $(clientSentimentParentElement).removeAttr('id').removeAttr('style');
   $(clientSentimentParentElement).find('#action_title_heading').text("Client Sentiment");
   $(clientSentimentParentElement).addClass('optional');
   $(clientSentimentParentElement).css("display", "none");

   // Application Container
   var applicationParentElement = $("#action_template_heading").clone();
   $(applicationParentElement).removeAttr('id').removeAttr('style');
   $(applicationParentElement).find('#action_title_heading').text("Applications");
   $(applicationParentElement).addClass('optional');
   $(applicationParentElement).css("display", "none");

   for (var key in actions) {
      var action = actions[key];

      if (action == actions.authentication_service
          || action.name == "Encryption Key"
          || action == actions.authentication_v3_service
          || action == actions.get_session_v1_service
          || action == actions.logout_service) {
         var authenticationChildElement = createElementFromAction(action);
         $(authenticationParentElement).find('#action_controls_heading').append(authenticationChildElement);
         $(authenticationParentElement).find('#action_parameter_field_check_box').click(function () {
            actions.authentication_service.parameters.post.encryptedPassword.value = $(authenticationParentElement).find('#action_parameter_field_check_box')[0].checked;
         });
         authenticationChildElement.css("display", "block");
      } else if(action == actions.market_search_service ||
          action == actions.browse ||
          action == actions.market_details ||
          action == actions.market_details_multi) {
         var marketSearchChildElement = createElementFromAction(action);
         $(searchParentElement).find('#action_controls_heading').append(marketSearchChildElement);
      } else if (action.name == "Account Watchlists" || action.name == 'Create Watchlist' || action.name == 'Delete Watchlist' || action.name == 'Add Instrument' || action.name == 'Remove Instrument') {
         var watchlistChildElement = createElementFromAction(action);
         $(watchlistParentElement).find('#action_controls_heading').append(watchlistChildElement);

      } else if (action.name == "Account Details" || action.name == "Account Switch" || action.name == "Get Account Settings" || action.name == "Update Account Settings") {
         var accountDetailsChildElement = createElementFromAction(action);
         $(clientParentElement).find('#action_controls_heading').append(accountDetailsChildElement);

      } else if (action == actions.open_positions_service ||
          action == actions.open_position_by_dealid_service ||
          action == actions.create_position  ||
          action == actions.edit_position ||
          action == actions.close_position ||
          action == actions.confirm) {
         var positionChildElement = createElementFromAction(action);
         $(tradingParentElement).find('#action_controls_heading').append(positionChildElement);

      } else if (action == actions.create_sprint_market_position || action == actions.get_sprint_market_positions) {
         var sprintMarketChildElement = createElementFromAction(action);
         $(tradingSprintMarketContainer).find('#action_controls_heading').append(sprintMarketChildElement);

      } else if (action.name == "Working Orders" ||
         action.name == "Create Working Order" ||
         action.name == "Edit Working Order" ||
         action.name == "Delete Working Order"
         ) {
         var workingOrderChildElement = createElementFromAction(action);
         $(tradingWOParentElement).find('#action_controls_heading').append(workingOrderChildElement);

      } else if (action == actions.transaction_history || action == actions.activity_history) {
         var transactionHistoryChildElement = createElementFromAction(action);
         $(accountActivityParentElement).find('#action_controls_heading').append(transactionHistoryChildElement);

      } else if (action == actions.price_search) {
         var historicPriceSearchChildElement = createElementFromAction(action);
         $(historicPriceSearchParentElement).find('#action_controls_heading').append(historicPriceSearchChildElement);

      } else if (
         action == actions.client_sentiment_single || action == actions.client_sentiment_multiple || action == actions.client_sentiment_related) {
         var clientSentimentChildElement = createElementFromAction(action);
         $(clientSentimentParentElement).find('#action_controls_heading').append(clientSentimentChildElement);

      } else if (
         action.name == "List Applications" || action.name == "Disable Application" || action.name == "Update Application") {
         var applicationChildElement = createElementFromAction(action);
         $(applicationParentElement).find('#action_controls_heading').append(applicationChildElement);

      }
   }

   // add elements in alphabetical order
   $(authenticationParentElement).appendTo('#sidebar');
   $(clientParentElement).appendTo('#sidebar');
   $(searchParentElement).appendTo('#sidebar');
   $(watchlistParentElement).appendTo('#sidebar');
   $(tradingParentElement).find('#action_controls_heading').append(tradingSprintMarketContainer);
   $(tradingParentElement).appendTo('#sidebar');
   $(tradingWOParentElement).appendTo('#sidebar');
   $(accountActivityParentElement).appendTo('#sidebar');
   $(historicPriceSearchParentElement).appendTo('#sidebar');
   $(clientSentimentParentElement).appendTo('#sidebar');
   $(applicationParentElement).appendTo('#sidebar');


   deployType = localStorage['deployType'] || 'live';
   $('#' + deployType).attr('checked', true);

   serverType = localStorage['serverType'] || 'tomcat';
   $('#' + serverType).attr('checked', true);

   req = new Request();
   req.nameE = document.getElementById("header_name");
   req.valueE = document.getElementById("header_value");
   req.nameE.value = req.hname;
   req.valueE.value = req.hvalue;
   $("#url").val(req.url);
   $("#content_body").val(req.body);
   var list = document.getElementById("header_list");

   var username = localStorage['username'];
   if (username != null) {
      $("#username").val(username);
   }

   list.innerHTML = renderHeaders();

   setEvents();
   $('.controls_toggle').hover(
      function () {
         $(this).css('cursor', 'pointer');
      },

      function () {
         $(this).css('cursor', 'auto');
      }
   );

   $('.controls').each(
      function () {
         var visibleState = localStorage[this.id];
         if (visibleState == 'hidden') {
            $(this).hide();
         } else if (visibleState == 'visible') {
            $(this).show();
         }
         if (this.id == "controls_login") {
            $(this).show();
         }
      }
   );

   $('.control_heading').addClass("ui-widget-header");
   $('.control').addClass("ui-widget-header-sub");
   $('.controls').addClass("ui-widget-content");

   $('input:button').button();

   $('.environment_buttons').buttonset();
   $('input:text').autocomplete();

});


function createElementFromAction(action) {
   var url = action.url;
   var noSpaceActionName = action.name.replace(/ /g, "_").toLowerCase();
   var urlParams = action.parameters.url || [];
   var postParams = action.parameters.post || [];

   var element = $("#action_template").clone();
   $(element).removeAttr('id').removeAttr('style');
   $(element).attr('id', noSpaceActionName);
   $(element).find('#action_title').text(action.name);
   $(element).find('#action_request_type').text(action.requestType);
   $(element).find('#action_url').text("/" + action.url);
   // rest doc urls tend to change; do not link to them
   $(element).find('#action_restdoc').attr("href", action.restdoc);
   $(element).find('.controls').attr('id', "controls_" + noSpaceActionName);

   $.each(action.parameters, function (index, paramCategory) {
      $.each(paramCategory, function (index, param) {

         var parameter = $('#action_parameter_template').clone();
         $(parameter).removeAttr('id').removeAttr('style');
         $(parameter).find('#action_parameter_title').text(param.displayName + ":");

         if (param.displayName == "Password" && param.hide == "true") {
            $(parameter).removeAttr('id').removeAttr('type');
            $(parameter).find('#action_parameter_field').prop('type', 'password');
         }

         var actionName = action.name.replace(/ /g, "_").toLowerCase();
         var paramName = param.displayName.replace(/ /g, "_").toLowerCase();
         var paramKey = actionName + "_" + paramName;

         if (actionName == "create_position") {
            if (paramName == "direction") {
               parameter = $('#action_parameter_template_radio').clone();
               $(parameter).removeAttr('id').removeAttr('style');
               $(parameter).find('#action_parameter_title_radio').text(param.displayName + ":");

               actionName = action.name.replace(/ /g, "_").toLowerCase();
               paramName = param.displayName.replace(/ /g, "_").toLowerCase();
               paramKey = actionName + "_" + paramName;
            }
         }
         if (param.type == Boolean) {
            parameter = $('#action_parameter_template_check_box').clone();
            $(parameter).removeAttr('id').removeAttr('style');
            $(parameter).find('#action_parameter_title_check_box').text(param.displayName + ":");
         }

         var keyListener = function () {
            param.value = $(this).val();
         };

         var saveData = function () {
            if (paramKey != "login_password") {
                localStorage[paramKey] = $(this).val();
            }
         };

         $(parameter).find('#action_parameter_field').blur(keyListener).keyup(keyListener);
         $(parameter).find('#action_parameter_field').blur(saveData).keyup(saveData);

         $(parameter).find('#action_parameter_field').autocomplete({autoFocus: true, source: param.suggestedValues || [], minLength: 0});

         if (paramName == "time_stamp") {
            var currentTimeMilli = Math.floor((new Date().getTime()) / 1000);
            $(parameter).find('#action_parameter_field').val(currentTimeMilli).trigger("keyup");
         }

         if (paramName == "risk_type") {
            $(parameter).find('#action_parameter_field').val("1").trigger("keyup");
         }

         var savedValue = localStorage[paramKey] || '';
         $(parameter).find('#action_parameter_field').val(savedValue).trigger('keyup');

         $(parameter).find('#action_parameter_field').attr('id', paramKey).addClass(paramName);

         $(element).find('#action_controls').append(parameter);
      });
   });

   $(element).find('#action_button').unbind().click(function () {
      performRequest(action);
   });

   element.addClass("ui-widget-content-sub");

   return element;
}

function objectSearch(obj, name) {
   for (var i in obj) {
      if (obj.hasOwnProperty(i)) {
         if (typeof obj[i] == 'object') {
            var found = objectSearch(obj[i], name);
            if (found) return found;
         }
         if (i == name) {
            return obj;
         }
      }
   }
   return null;
}

function getApiGatewayBaseUrl() {
   if ($('#custom_server_checkbox').attr('checked')) {
      return $('#custom_server').val();
   } else {
      return servers[serverSelection] + "/gateway/deal";
   }
}

function refreshAccessToken(refreshToken, apiKey) {
   var baseUrl = getApiGatewayBaseUrl();
   var url = baseUrl + "/session/refresh-token";
   var body = "{ \"refresh_token\": \"" + refreshToken + "\" }";
   var headers = {
      "Content-Type": "application/json",
      "X-IG-API-KEY": apiKey
   };
   console.log("Refreshing OAuth access token with refresh_token=" + refreshToken);
   $.ajax({
      type: "POST",
      url: url,
      data: body,
      headers: headers,
      async: false,
      mimeType: null,
      success: function (response, status, data) {
         lastResponse = response;
      },
      complete: function (response) {
         isLoggedIn = false;
         if (response.status == 200) {
            var body = JSON.parse(response.responseText)
            handleOAuthAccessTokenResponse(body, apiKey);
         }
      }
   });
}

function handleOAuthAccessTokenResponse(accessTokenResponse, apiKey) {
   if (accessTokenResponse) {
      var accessToken = accessTokenResponse["access_token"];
      var refreshToken = accessTokenResponse["refresh_token"];
      req.nameE.value = "Authorization";
      req.valueE.value = accessToken ? "Bearer " + accessToken : "##";
      onAddChangeHeader();
      isLoggedIn = true;
      var expiresInMillis = accessTokenResponse["expires_in"] * 1000;
      console.log("Received OAuth access_token=" + accessToken + " and refresh_token=" + refreshToken + " with expiryMillis=" + expiresInMillis);
      oauthRefreshTimer = setTimeout(function () {
         if(isLoggedIn) {
            refreshAccessToken(refreshToken, apiKey);
         }
      }, expiresInMillis - 5000);      // Refresh 5 seconds before expiring
   }
}

function performRequest(action) {
   actionGlobal = action;
   var baseUrl = getApiGatewayBaseUrl();

   var url = baseUrl + '/' + action.url;

   var requestType = action.requestType;
   var urlParams = action.parameters.url || [];
   var postParams = action.parameters.post || [];
   var queryParams = action.parameters.query || [];

   $.each(urlParams, function (index, param) {
      param.value = param.value || '';
      if (param.value) {
         url = url + '/' + encodeURIComponent(param.value);
      }
   });

   var query = [];
   $.each(queryParams, function (index, param) {
      param.value = param.value || '';
      if (param.value) {
         query.push(index + "=" + encodeURIComponent(param.value));
      }
   });

   if ($('#dark_pool_checkbox').attr('checked')) {
      query.push("deal_cluster=dark");
   }

   var deployTypeQuery = deployTypes[deployType];

   if (deployTypeQuery.length > 0) {
      if (query.length > 0) {
         url = url + deployTypeQuery + '&' + query.join('&');
      } else {
         url = url + deployTypeQuery;
      }
   } else {
      if (query.length > 0) {
         url = url + "?" + query.join('&');
      }
   }

   var postParamObj = {};
   var actionName = action.name.replace(/ /g, "_").toLowerCase();

   // the request body, can be assembled in two different ways
   var body;

   if (action.payloadTemplate) {

      // structured request body, we use a template and fill in the blanks using the form fields

      var restBody = action.payloadTemplate;

      for (var property in postParams) {
         var propertyField = objectSearch(restBody, property);
         propertyField[property] = postParams[property].value;
      }

      body = JSON.stringify(restBody);

   } else {

      //regular form, plain field handling

      $.each(postParams, function (index, param) {
         param.value = param.value || null;
         if (param.type == 'list') {
            if (param.value != null) {
               postParamObj[index] = param.value.split(',');
            }
         } else {

            var paramName = param.displayName.replace(/ /g, "_").toLowerCase();

            if (actionName == "create_position") {
               if (paramName == "direction") {
                  if (radio_button_value == "Buy") {
                     param.value = "BUY";
                  }
                  else {
                     param.value = "SELL";
                  }
               }
            }

            if ((paramName != "user_agent") && (paramName != "application_key")) {
               postParamObj[index] = param.value;
            }
         }
      });

      // Encrypt the login password if required
      if (action == actions.authentication_service && postParamObj['encryptedPassword'] == true) {
         $.ajax({
            async: false,
            url: baseUrl + "/session/encryptionKey",
            headers: {
               'X-IG-API-KEY' : action.parameters.post.vendorKey.value
            }
         })
             .done(function(data) {
                postParamObj['password'] = PS.util.encryption.encrypt(
                    postParamObj['password'] + "|" + data.timeStamp,
                    data.encryptionKey);
             })
             .fail(function (xhr, textStatus, error) {
                alert("Failed to encrypt password: " + error);
             });
      }

      body = js_beautify(JSON.stringify(postParamObj));
   }


   $("#url").val(url);
   $("#content_body").val(body);

   req.binary = action.binary;
   req.version = action.version;

   if (action == actions.authentication_service || action == actions.authentication_v3_service) {
      isLoggedIn = false;
      removeAllHeaders();
      req.nameE.value = "X-IG-API-KEY";
      req.valueE.value = action.parameters.post.vendorKey.value || "##";
      onAddChangeHeader();
   } else if (!isLoggedIn) {
      alert("Please log in first.");
      return;
   }

   doRequest(requestType);

   if (action == actions.logout_service) {
      isLoggedIn = false;
      delete req.headers["X-SECURITY-TOKEN"];
      delete req.headers["CST"];
      delete req.headers["X-IG-API-KEY"];
   }

   if (action == actions.authentication_service || action == actions.authentication_v3_service) {
      showPanels();
   }
}

function onUsernameChanged() {
   localStorage['username'] = $("#username").val();
}

function onPasswordChanged() {
   //localStorage['password'] = $("#password").val();
}


function onHeaderChanged() {
   req.hname = req.nameE.value;
   req.hvalue = req.valueE.value;
}

function renderHeaders() {
   var html = '<table border id="header_table">';
   html += "<tr><th>Name</th><th>Value</th></tr>";
   for (var i in req.headers) {
      html += "<tr><td align=\"left\">" + i + "</td><td align=\"right\">" + req.headers[i] + "</td></tr>";
   }
   html += "</table>"
   return html;
}

function onAddChangeHeader() {
   var name = req.nameE.value;
   if (!name) {
      return;
   }
   var value = req.valueE.value;
   if (value == "##") {
      delete req.headers[name];
   } else {
      req.headers[name] = value;
   }
   req.nameE.value = req.valueE.value = "";
   onHeaderChanged();
   var list = document.getElementById("header_list");
   list.innerHTML = renderHeaders();
}

function onRemoveAccessTokens() {
   delete req.headers["X-SECURITY-TOKEN"];
   delete req.headers["CST"];
   delete req.headers["Authorization"];
   var list = document.getElementById("header_list");
   list.innerHTML = renderHeaders();
}

function onRemoveAccountIdHeader() {
   delete req.headers["IG-ACCOUNT-ID"];
   var list = document.getElementById("header_list");
   list.innerHTML = renderHeaders();
}

function onRemoveApiKeyHeader() {
   delete req.headers["X-IG-API-KEY"];
   var list = document.getElementById("header_list");
   list.innerHTML = renderHeaders();
}

function removeAllHeaders() {
   clearTimeout(oauthRefreshTimer);
   delete req.headers["X-SECURITY-TOKEN"];
   delete req.headers["CST"];
   delete req.headers["Authorization"];
   delete req.headers["IG-ACCOUNT-ID"];
   delete req.headers["X-IG-API-KEY"];
   delete req.headers["Version"];

   var list = document.getElementById("header_list");
   list.innerHTML = renderHeaders();
}

function doCustomRequest(method) {
   doRequest(method);
}

function doRequest(method) {
   req.method = method;
   req.url = $("#url").val();
   if (req.method == "POST" || req.method == "PUT" || req.method == "DELETE") {
      req.body = $("#content_body").val();
   } else {
      req.body = "";
      $("#content_body").val("");
   }
   //Override in case DELETE methods are not supported.
   if (req.method == "DELETE") {
      req.headers["_method"]="DELETE";
      req.method = "POST";
      $("#url").val(req.url);
   }

   var fullPathToInstance = req.url;

   req.nameE.value = "Version";
   if (req.version) {
      req.valueE.value = req.version;
   } else {
      req.valueE.value = "1";
   }
   onAddChangeHeader();

   req.nameE.value = "Accept";
   if (req.binary) {
      req.valueE.value = "*/*";
   } else {
      req.valueE.value = "application/json; charset=UTF-8";
   }
   onAddChangeHeader();

   console.log(method + " " + req.url);

   $.ajax({
      type: req.method,
      url: req.url,
      data: req.body,
      headers: req.headers,
      async: false,
      //mimeType: null,
      mimeType: req.binary ? 'text/plain; charset=x-user-defined' : null,
      success: function (response, status, data) {
         console.log("success");
         lastResponse = response;
      },
      complete: function (response) {
         renderResponse(response);
      }
   });
}

function highlightKeys() {

   highlight('epic', document.getElementById("response_body"), "Click to view market details");
   highlight('dealId', document.getElementById("response_body"), "Click to set dealId on relevant endpoints");
   highlight('id', document.getElementById("response_body"), "Click to retrieve item");
   highlightNoClick('instrumentName', document.getElementById("response_body"));
   highlightNoClick('marketName', document.getElementById("response_body"));

   if(!req.headers["X-SECURITY-TOKEN"]) {
      highlight('accountId', document.getElementById("response_body"), "Click to set account id");

      $(".highlight_accountId").click(function () {
         var regex = /"accountId": "(.*?)".*/g;
         var accountId = regex.exec($(this).html())[1];
         $(".accountId").val(accountId).trigger("keyup");
         req.nameE.value = "IG-ACCOUNT-ID";
         req.valueE.value = accountId;
         $("#response_body").show().html("Current account: " + accountId);
         onAddChangeHeader();
      });
   }

   $(".highlight_epic").click(function () {
      var regex = /"epic": "(.*?)".*/g;
      var epic = regex.exec($(this).html())[1];
      $(".epic").val(epic).trigger("keyup");
      performRequest(actions.market_details);
      $(".expiry").val(lastResponse.instrumentData.expiry).trigger("keyup");
   });

   $(".highlight_id").click(function () {
      var regex = /"id": "(.*?)"/g;
      var id = regex.exec($(this).html())[1];

      var url = $("#url").val();
      if (url.indexOf("watchlists") != -1) {
         $(".watchlist_id").val(id).trigger("keyup");
         setField(actions.account_watchlists.parameters.url.id, "account_watchlists_watchlist_id", id);
         performRequest(actions.account_watchlists);
      } else if (url.indexOf("/marketnavigation") != -1) {
         setField(actions.browse.parameters.url.id, "browse_markets_hierarchy_id", id);
         performRequest(actions.browse);
      }
   });

   $(".highlight_dealId").click(function (response) {
      var regex = /"dealId": "(.*?)"/g;
      var id = regex.exec($(this).html())[1];

      var url = $("#url").val();
      if (url.indexOf("positions") != -1) {
         $(lastResponse.positions).each(function (index) {
            var positionData = lastResponse.positions[index];
            if (positionData.position.dealId == id) {
                // Set get position fields
                setField(actions.open_position_by_dealid_service.parameters.url.dealId, "open_position_dealid", id);
               // Set edit position fields
               setField(actions.edit_position.parameters.url.dealId, "edit_position_deal_id", id);
               setField(actions.edit_position.parameters.post.stopLevel, "edit_position_stop_level", positionData.position.stopLevel);
               setField(actions.edit_position.parameters.post.limitLevel, "edit_position_limit_level", positionData.position.limitLevel);
               // Set close position fields
               setField(actions.close_position.parameters.post.dealId, "close_position_deal_id", id);
               if (positionData.position.direction == "BUY") {
                  setField(actions.close_position.parameters.post.direction, "close_position_direction", "SELL");
               } else {
                  setField(actions.close_position.parameters.post.direction, "close_position_direction", "BUY");
               }
               setField(actions.close_position.parameters.post.size, "close_position_deal_size", positionData.position.dealSize);
               setField(actions.close_position.parameters.post.orderType, "close_position_order_type", "MARKET");
               setField(actions.close_position.parameters.post.epic, "close_position_epic", "");
               setField(actions.close_position.parameters.post.expiry, "close_position_expiry", "");
               setField(actions.close_position.parameters.post.level, "close_position_closing_order_level", "");
               setField(actions.close_position.parameters.post.quoteId, "close_position_quote_id", "");

            }
         });

      } else if (url.indexOf("workingorders") != -1) {

         $(lastResponse.workingOrders).each(function (index) {
            var workingOrder = lastResponse.workingOrders[index];
            if (workingOrder.workingOrderData.dealId == id) {
               // Set edit working order
               setField(actions.edit_working_order.parameters.url.dealId, "edit_working_order_deal_id", id);
               setField(actions.edit_working_order.parameters.post.timeInForce, "edit_working_order_time_in_force", workingOrder.workingOrderData.goodTill);
               setField(actions.edit_working_order.parameters.post.stopLevel, "edit_working_order_stop_level", workingOrder.workingOrderData.contingentStop);
               setField(actions.edit_working_order.parameters.post.limitLevel, "edit_working_order_limit_level", workingOrder.workingOrderData.contingentLimit);
               setField(actions.edit_working_order.parameters.post.type, "edit_working_order_order_type", workingOrder.workingOrderData.requestType);
               setField(actions.edit_working_order.parameters.post.level, "edit_working_order_order_level", workingOrder.workingOrderData.level);
               // Set create working order
               setField(actions.create_working_order.parameters.post.dealId, "create_working_order_deal_id", id);
               setField(actions.create_working_order.parameters.post.direction, "create_working_order_direction", workingOrder.workingOrderData.direction);
               setField(actions.create_working_order.parameters.post.currencyCode, "create_working_order_currency_code", workingOrder.workingOrderData.currencyCode);
               setField(actions.create_working_order.parameters.post.size, "create_working_order_order_size", workingOrder.workingOrderData.size);
               setField(actions.create_working_order.parameters.post.timeInForce, "create_working_order_time_in_force", workingOrder.workingOrderData.goodTill);
               setField(actions.create_working_order.parameters.post.stopLevel, "create_working_order_stop_level", workingOrder.workingOrderData.contingentStop);
               setField(actions.create_working_order.parameters.post.limitLevel, "create_working_order_limit_level", workingOrder.workingOrderData.contingentLimit);
               setField(actions.create_working_order.parameters.post.type, "create_working_order_order_type", workingOrder.workingOrderData.requestType);
               setField(actions.create_working_order.parameters.post.level, "create_working_order_order_level", workingOrder.workingOrderData.level);
               setField(actions.create_working_order.parameters.post.guaranteedStop, "create_working_order_guaranteed_stop", workingOrder.workingOrderData.controlledRisk);
               // set delete working order
               setField(actions.delete_working_order.parameters.url.dealId, "delete_working_order_deal_id", id);

            }
         });

      }
   });

   $('.highlight_id, .highlight_dealId, .highlight_epic, .highlight_accountId').hover(
      function () {
         $(this).css('cursor', 'pointer');
      },

      function () {
         $(this).css('cursor', 'auto');
      }
   );
}

function setField(actionId, fieldId, value) {

   //actionId.value = value;
   $("#" + fieldId).val(value).trigger("keyup");

}

function highlight(word, element, comment) {
   var rgxp = new RegExp('("' + word + '": "(.*?)")', 'g');
   var repl = '<span title="' + comment + '" class="highlighted highlight_' + word + '">$1</span>';
   element.innerHTML = element.innerHTML.replace(rgxp, repl);
}

function highlightNoClick(word, element, func) {
   var rgxp = new RegExp('("' + word + '": "(.*?)")', 'g');
   var repl = '<span class="highlightedNoClick highlight_' + word + '">$1</span>';
   element.innerHTML = element.innerHTML.replace(rgxp, repl);
}

function setEvents() {
   $('#username').keyup(onUsernameChanged).blur(onUsernameChanged);
   $('#password').keyup(onPasswordChanged).blur(onPasswordChanged);

   var saveText = function () {
      if (this.id != "login_password") {
        localStorage[this.id] = $(this).val();
      }
   };

   var toggleCheckbox = function () {
      $('#custom_server_checkbox').attr('checked', Boolean($(this).val()));
   };

   var saveCheckbox = function () {
      localStorage[this.id] = $(this).attr('checked') || '';
      localStorage['custom_server'] = 'http://localhost/gateway/deal';
   };

   var saveDarkPoolCheckbox = function () {
      localStorage[this.id] = $(this).attr('checked') || '';
   };

   $('#custom_server').keyup(saveText).keyup(toggleCheckbox).blur(saveText).blur(toggleCheckbox);
   $('#custom_server_checkbox').change(saveCheckbox);

   $('#dark_pool_checkbox').change(saveDarkPoolCheckbox);

   $('#get_button').click(function () {
      doCustomRequest('GET');
   });
   $('#post_button').click(function () {
      doCustomRequest('POST');
   });
   $('#head_button').click(function () {
      doCustomRequest('HEAD');
   });
   $('#put_button').click(function () {
      doCustomRequest('PUT');
   });
   $('#delete_button').click(function () {
      doCustomRequest('DELETE');
   });
   $('#options_button').click(function () {
      doCustomRequest('OPTIONS');
   });

   $('#add_header').click(onAddChangeHeader);
   $('#header_remove_access_tokens').click(onRemoveAccessTokens);
   $('#header_remove_api_key').click(onRemoveApiKeyHeader);
   $('#header_remove_account_id').click(onRemoveAccountIdHeader);

   $('.controls_toggle').click(function () {
      $(this).next().slideToggle(300, function () {
         $('.controls:hidden').each(function () {
            localStorage.setItem(this.id, 'hidden');
         });
         $('.controls:visible').each(function () {
            localStorage.setItem(this.id, 'visible');
         });
      });
   });

   $('#tool_collapse_all').click(function () {
      $('.controls').hide();
      $('#tools').show();
   });

   $('#tool_open_all').click(function () {
      $('.controls').show();
   });

   $('input[name=custom_server_checkbox]:checkbox').click(function () {
      if ($('input[name=custom_server_checkbox]').is(':checked')) {
         $('#custom_server').val("http://localhost/gateway/deal");
      } else {
         $('#custom_server').val("");
      }
   });

   $('input[name=action_parameter_field_radio]:radio').click(function () {

      radio_button_value = getRadioValue();
      var responseBody = $("#response_body");

      var regexDisplayBid = /"displayBid": "(.*?)"/g;
      var match = regexDisplayBid.exec(responseBody.html());
      if (match != null) {
         var displayBid = match[1];
      }

      var regexDisplayOffer = /"displayOffer": "(.*?)"/g;
      match = regexDisplayOffer.exec(responseBody.html());
      if (match != null) {
         var displayOffer = match[1];
      }

   });


   $('input[name=action_parameter_field_radio_v1]:radio').click(function () {

      radio_button_value_v1 = getRadioValueV1();
      var responseBody = $("#response_body");

      var regexDisplayBid = /"displayBid": "(.*?)"/g;
      var match = regexDisplayBid.exec(responseBody.html());
      if (match != null) {
         var displayBid = match[1];
      }

      var regexDisplayOffer = /"displayOffer": "(.*?)"/g;
      match = regexDisplayOffer.exec(responseBody.html());
      if (match != null) {
         var displayOffer = match[1];
      }

      if (radio_button_value_v1 == "Buy") {
         if (displayOffer != null) {
            $("#create_position_v1_display_order_level").val(displayOffer).trigger("keyup");
         }
      }
      else {
         if (displayBid != null) {
            $("#create_position_v1_display_order_level").val(displayBid).trigger("keyup");
         }
      }
   });
}

function renderResponse(response) {
   var result = "status: <b>" + response.statusText + "</b><br/><br/>";
   var header = response.getAllResponseHeaders();
   var all = header.split("\r\n");
   all.sort();

   // important headers
   for (var i = 0; i < all.length; i++) {
      var hdr = all[i];
      if (hdr != "") {
         if (hdr.indexOf("X-COLOUR:") > -1 || hdr.indexOf("X-SERVER:") > -1 || hdr.indexOf("X-INSTANCE-NUMBER:") > -1) {
            result += ("<b>" + hdr + "</b><br>");
         }
      }
   }

   for (var i = 0; i < all.length; i++) {
      var hdr = all[i];
      if (hdr != "") {
         if (hdr.indexOf("Content-Type:") > -1 || hdr.indexOf("X-SECURITY-TOKEN:") > -1 || hdr.indexOf("CST:") > -1 || hdr.indexOf("X-IG-Cookie:") > -1) {
            result += (hdr + "<br>");
         }
      }
   }

   colorPropertyFound = false;
   for (var i = 0; i < all.length; i++) {
      var hdr = all[i];
      if (hdr != "") {
         if (hdr.indexOf("X-COLOUR:") > -1) {
            if (hdr.indexOf("blue") > -1) {
               colorPropertyFound = true;
               if (req.url.indexOf("dark") > -1) {
                  clusterColorForDark = "Blue";
                  clusterColorForLive = "Green";
               } else {
                  clusterColorForLive = "Blue";
                  clusterColorForDark = "Green";
               }
            } else if (hdr.indexOf("green") > -1) {
               colorPropertyFound = true;
               if (req.url.indexOf("dark") > -1) {
                  clusterColorForDark = "Green";
                  clusterColorForLive = "Blue";
               } else {
                  clusterColorForLive = "Green";
                  clusterColorForDark = "Blue";
               }
            }
            labelFontColorForPressed = "Red";
            labelFontColorForNotPressed = "White";
            break;
         }
      }
   }

   if (!colorPropertyFound) {
      clusterColorForDark = "Red";
      clusterColorForLive = "Red";
      labelFontColorForPressed = "White";
      labelFontColorForNotPressed = "White";
   }

   // unimportant headers
   var haveAddedSmall = false;
   for (var i = 0; i < all.length; i++) {
      var hdr = all[i];
      if (hdr != "") {
         if (hdr.indexOf("Content-Type:") > -1 || hdr.indexOf("X-SECURITY-TOKEN:") > -1 || hdr.indexOf("CST:") > -1 || hdr.indexOf("X-IG-Cookie:") > -1) {
            // we already added this
         } else if (hdr.indexOf("X-COLOUR:") > -1 || hdr.indexOf("X-SERVER:") > -1 || hdr.indexOf("X-INSTANCE-NUMBER:") > -1) {
            // we already added this as well
         } else {
            if (!haveAddedSmall) {
               haveAddedSmall = true;
               result += "<br/><small>";
            }
            result += (hdr + "<br>");
         }
      }
   }

   if (haveAddedSmall) {
      result += "</small>";
   }

   // Remove _method header
   delete req.headers["_method"];

   var h2Style = getHttpStatusH2Style(response.status);

   $("#response_header").html("<h2" + h2Style + ">HTTP " + response.status + "</h2>" + result);

   $(".environment_buttons label").eq(24).css("background-color", clusterColorForLive);
   $(".environment_buttons label").eq(24).css("background-image", "none");

   $(".environment_buttons label").eq(25).css("background-color", clusterColorForDark);
   $(".environment_buttons label").eq(25).css("background-image", "none");

   if (isLivePressed) {
      $(".environment_buttons label").eq(24).css("color", labelFontColorForPressed);
      $(".environment_buttons label").eq(25).css("color", labelFontColorForNotPressed);
   } else {
      $(".environment_buttons label").eq(24).css("color", labelFontColorForNotPressed);
      $(".environment_buttons label").eq(25).css("color", labelFontColorForPressed);
   }

   if (response.getResponseHeader("Content-Type") == "image/png") {
      $('#response_image').show().attr('src', "data:image/png;base64," + Base64.encodeBinary(response.responseText));
      $("#response_body").hide();

   } else {
      $('#response_image').hide();
      $("#response_body").show().text(js_beautify(response.responseText || ""));


      // RESPONSE HANDLING
      var responseBody = $("#response_body");
      var responseText = responseBody.html();
      if((isAuthenticateRequest(req, actions) || isAccountSwitchRequest(req, actions)) && response.status == 200) {
         isLoggedIn = true;
         var token = response.getResponseHeader("X-SECURITY-TOKEN");
         if (token) {
            req.nameE.value = "X-SECURITY-TOKEN";
            req.valueE.value = token;
            onAddChangeHeader();
         }
         var clientSecurityToken = response.getResponseHeader("CST");
         if (clientSecurityToken) {
            req.nameE.value = "CST";
            req.valueE.value = clientSecurityToken;
            onAddChangeHeader();
         }
      }
      else if(isAuthenticateV3Request(req, actions) && response.status == 200) {
         var body = JSON.parse(responseText);
         if (body) {
            var apiKey = req.headers["X-IG-API-KEY"];
            handleOAuthAccessTokenResponse(body["oauthToken"], apiKey)
            req.nameE.value = "IG-ACCOUNT-ID";
            req.valueE.value = body["accountId"];
            onAddChangeHeader();
            isLoggedIn = true;
         }
      }

      highlightKeys();

      $('#response').show();
   }
}

function isAuthenticateV3Request(req, actions) {
   return new RegExp('^' + getApiGatewayBaseUrl() + "/" + actions.authentication_v3_service.url).test(req.url) && req.method == actions.authentication_v3_service.requestType && req.version == actions.authentication_v3_service.version;
}

function isAuthenticateRequest(req, actions) {
   return new RegExp('^' + getApiGatewayBaseUrl() + "/" + actions.authentication_service.url).test(req.url) && req.method == actions.authentication_service.requestType && req.version == actions.authentication_service.version;
}

function isAccountSwitchRequest(req, actions) {
   return new RegExp('^' + getApiGatewayBaseUrl() + "/" + actions.account_switch.url).test(req.url) && req.method == actions.account_switch.requestType && req.version == actions.account_switch.version;
}

function getHttpStatusH2Style(status) {
   var h2Style = "";
   if (status == 0 || status >= 300) {
      h2Style = ' class="responseBad"';
   } else {
      h2Style = ' class="responseGood"';
   }
   return h2Style;
}

function getRadioValue() {
   if ($('input[name=action_parameter_field_radio]:radio:checked').length > 0) {
      return $('input[name=action_parameter_field_radio]:radio:checked').val();
   }
   else {
      return 0;
   }
}

function getRadioValueV1() {
   if ($('input[name=action_parameter_field_radio_v1]:radio:checked').length > 0) {
      return $('input[name=action_parameter_field_radio_v1]:radio:checked').val();
   }
   else {
      return 0;
   }
}

Base64 = {

   // private property
   _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

   encodeBinary: function (input) {
      var output = "";
      var bytebuffer;
      var encodedCharIndexes = new Array(4);
      var inx = 0;
      var paddingBytes = 0;

      console.log("base64 input " + input.length);

      while (inx < input.length) {
         // Fill byte buffer array
         bytebuffer = new Array(3);
         for (jnx = 0; jnx < bytebuffer.length; jnx++)
            if (inx < input.length)
               bytebuffer[jnx] = input.charCodeAt(inx++) & 0xff; // throw away high-order byte, as documented at: https://developer.mozilla.org/En/Using_XMLHttpRequest#Handling_binary_data
            else
               bytebuffer[jnx] = 0;

         // Get each encoded character, 6 bits at a time
         // index 1: first 6 bits
         encodedCharIndexes[0] = bytebuffer[0] >> 2;
         // index 2: second 6 bits (2 least significant bits from input byte 1 + 4 most significant bits from byte 2)
         encodedCharIndexes[1] = ((bytebuffer[0] & 0x3) << 4) | (bytebuffer[1] >> 4);
         // index 3: third 6 bits (4 least significant bits from input byte 2 + 2 most significant bits from byte 3)
         encodedCharIndexes[2] = ((bytebuffer[1] & 0x0f) << 2) | (bytebuffer[2] >> 6);
         // index 3: forth 6 bits (6 least significant bits from input byte 3)
         encodedCharIndexes[3] = bytebuffer[2] & 0x3f;

         // Determine whether padding happened, and adjust accordingly
         paddingBytes = inx - (input.length - 1);
         switch (paddingBytes) {
            case 2:
               // Set last 2 characters to padding char
               encodedCharIndexes[3] = 64;
               encodedCharIndexes[2] = 64;
               break;
            case 1:
               // Set last character to padding char
               encodedCharIndexes[3] = 64;
               break;
            default:
               break; // No padding - proceed
         }
         // Now we will grab each appropriate character out of our keystring
         // based on our index array and append it to the output string
         for (jnx = 0; jnx < encodedCharIndexes.length; jnx++)
            output += this._keyStr.charAt(encodedCharIndexes[jnx]);
      }

      console.log("base64 outout " + output.length);

      return output;
   }
};

function configure() {

   var url = window.location.href;
   var env = url.match("https?:\/\/(.*)-labs.ig.com");
   var enableDevMode = url.substring(url.length - "dev=true".length, url.length ) == "dev=true";
   if (enableDevMode || url.match(".*localhost.*") || url.match("chrome-extension://*")) {
      mode = "dev";
   } else if (env && env.length > 1) {
      mode = env[1].toLowerCase();
      console.log("Changing mode from dev to " + mode)
   } else {
      mode= "live";
   }
   if (mode == "dev") {
      addServerButton("Dev");
      addServerButton("Net");
      addServerButton("Web");
   } else if (mode == "net") {
      addServerButton("Net");
      addServerButton("Web");
   } else if (mode == "web") {
      addServerButton("Web");
   }
   addServerButton("Demo");
   addServerButton("Prod");

   serverSelection = localStorage['serverSelection'] || 'demo_ig';
   $('#' + serverSelection).attr('checked', true);

    if (mode == "dev") {
       console.log("Mode: " + mode);
       $('#custom_server').val(localStorage['custom_server']);
       $('#custom_server_checkbox').attr('checked', Boolean(localStorage['custom_server_checkbox']));
       $("#custom_server_container").css("display", "block");

       $('#dark_pool_checkbox').attr('checked', Boolean(localStorage['dark_pool_checkbox']));
       $("#dark_pool_container").css("display", "block");
    } else {
       $('#custom_server_checkbox').attr('checked', false);
       $('#dark_pool_checkbox').attr('checked', false);
    }

    }

function addServerButton(serverName) {

   var serverId = serverName.toLowerCase() + '_ig';
   $(".environment_buttons").append('<input type="radio" name="environment" value="' + serverName + '" id="' + serverId + '"/><label for="' + serverId + '">' + serverName + '</label>');
   $('#' + serverId).click(function () {
      console.log("click " + serverId);
      serverSelection = serverId;
      localStorage['serverSelection'] = serverSelection;

   });

}

function showPanels() {
   if (mode == "dev") {
      console.log("Mode: " + mode);
   }
   $("#header_control").css("display", "block");
   $("#logout").css("display", "block");
   $(".optional").css("display", "block");
   $("#landing").css("display", "none");

}


